<?php


namespace FiloBlu\Kpi\Console\Command;

use FiloBlu\Kpi\Cron\AddkpidataFactory;
use Magento\Framework\App\State;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

/**
 * Class AddkpidataCommand
 * @package FiloBlu\Kpi\Console\Command
 */
class AddkpidataCommand extends Command
{
    /**
     * @var
     */
    protected $addkpidataFactory;
    /**
     * @var State
     */
    protected $state;

    /**
     * AddkpidataCommand constructor.
     * @param AddkpidataFactory $addkpidataFactory
     * @param State $state
     */
    public function __construct(
        AddkpidataFactory $addkpidataFactory,
        State $state
    )
    {
        $this->addkpidataFactory = $addkpidataFactory;
        $this->state = $state;
        parent::__construct();
    }

    /**
     * {@inheritdoc}
     */
    protected function configure()
    {
        $this->setName('kpi:addkpidata');
        $this->setDescription('Add KPI data');
        parent::configure();
    }

    /**
     * {@inheritdoc}
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {

        try {
            $this->state->setAreaCode(\Magento\Framework\App\Area::AREA_ADMINHTML);
        } catch (\Exception $e) {
            $output->writeln('Areacode was already set, skipping!');
        }

        $now = new \DateTime();
        $output->writeln('Add KPI data operation start at ' . $now->format('H:i:s') . '. Check the log for details.');
        $this->addkpidataFactory->create()->execute();
        $now = new \DateTime();
        $output->writeln('End operation at ' . $now->format('H:i:s'));
    }
}